/*
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the LAM/MPI software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * LAM/MPI source distribution.
 * 
 * $HEADER$
 *
 *	Revision 6.1  1996/11/23 21:55:44  nevin
 *	Ohio Release
 *	
 * Revision 6.0  96/02/29  13:54:09  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  14:00:50  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:44:46  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:49:11  gdburns
 * Ohio Release
 * 
 * Revision 2.2  93/10/14  18:28:53  raja
 * pre-release to 2.3
 * 
 *	Function:	- virtual circuits templates and constants
 */

#ifndef _VCTABLE
#define _VCTABLE

#include <portable.h>

/*
 * constants
 */
#define VCMAX		67		/* VC table size (prime #) */

/*
 * hashing macro
 */
#define _vchash(n,e,t)	(abs((n) + (e) + (t)) % VCMAX)

/*
 * templates
 */
struct vcdesc {
	int4		vc_node;	/* node identifier */
	int4		vc_event;	/* message event */
	int4		vc_type;	/* event type */
	int4		vc_path;	/* VC path */
};

#endif
